;******************************************************************************
;                                                                             *
;     : GSM.asm                                                       *
;    : 12.07.2011                                                        *
;    : 1                                                                *
;                                                                             *
;    :                                                       *
;                                                                             *
;                                                                             *
;******************************************************************************
;                                                                             *
;    : PIC12F683                                               *
;    :  , 4.                                   *
;    : .                                                              *
;                                                                             *
;******************************************************************************
;                                                                             *
;     :                                                      *
;    GSM    -                           *
;    - "".                                               *
;     "" -  .                                            *
;     "" -  .                                          *
;         .                           *
;                              *
;      .                                                 *
;                                                                             *
;******************************************************************************
;                                                                             *
;    : 482    .                             *
;                                                                             *
;******************************************************************************

;------------------------------------------------------------------------------
;   :
;------------------------------------------------------------------------------
            LIST        P=12F683    ; PIC12F683
;------------------------------------------------------------------------------
;   :
;------------------------------------------------------------------------------
            __CONFIG    0F00Ch      ; (0000 1111 0000 0000 1100)
                                    ; WDT - .(on, enabled)
                                    ; PWRT - .(on, enabled)
                                    ; CP - .(on, enabled)
                                    ; CPD - .(on, enabled)
                                    ; BOR - .(off, disabled)
                                    ; GP3 -  .
;------------------------------------------------------------------------------
;     .
;------------------------------------------------------------------------------
Status      equ         03h         ;   .
TrisIO      equ         05h         ;    
                                    ;  GPIO.
GPIO        equ         05h         ;     GPIO.
IntCon      equ         0Bh         ;  INTCON.
Cmcon0      equ         19h         ;   .
Ansel       equ         9Fh         ;    .
Option_Reg  equ         81h         ;  OPTION.
Wpu         equ         95h         ;   
                                    ;   GPIO.
Vrcon       equ         99h         ;    .
;------------------------------------------------------------------------------
;       .
;------------------------------------------------------------------------------
W_Temp      equ         26h         ;    W 
                                    ; .
Stat_Temp   equ         27h         ;    Status 
                                    ; .
Perem       equ         28h         ;  Perem.
Bitvkl      equ         29h         ; ,  .
Bitvykl     equ         2Ah         ; ,  .
Bitsost     equ         2Bh         ; ,  .
Bitpost     equ         2Ch         ; ,    .
BitGen      equ         2Dh         ; ,   .
SecL        equ         22h         ;   .
SecM        equ         21h         ;   .
SecH        equ         20h         ;   .
Taimer8     equ         37h         ;  .
Taimer7     equ         36h         ;  .
Taimer6     equ         35h         ;  .
Taimer5     equ         34h         ;  .
Taimer4     equ         33h         ;  .
Taimer3     equ         32h         ;  .
Taimer2     equ         31h         ;  .
Taimer1     equ         30h         ;  .
SecLp       equ         42h         ;   ,  .
SecMp       equ         41h         ;   ,  .
SecHp       equ         40h         ;   ,  .
;------------------------------------------------------------------------------
;     .
;------------------------------------------------------------------------------
W           equ         00h          ;    .
F           equ         01h          ;    .
;------------------------------------------------------------------------------
;                     .
;                (    )
;------------------------------------------------------------------------------
RP0         equ         05h         ;   .
GP0         equ         00h         ;  .   2500 .
GP1         equ         01h         ;   .
GP2         equ         02h         ;   .
GP3         equ         03h         ;   .
GP4         equ         04h         ;  ""  .
GP5         equ         05h         ;  ""  .
COUT        equ         06h         ;  .
INTF        equ         01h         ;  .
Z           equ         02h         ;   .
;------------------------------------------------------------------------------
;    .
;------------------------------------------------------------------------------
            org         0x00        ;    
                                    ;   PC.
            goto        St          ;    
                                    ;  St.
;------------------------------------------------------------------------------
;    .
;------------------------------------------------------------------------------
            org         0x04
;------------------------------------------------------------------------------
;    .
;------------------------------------------------------------------------------

;==============================================================================
;  .
;------------------------------------------------------------------------------
Int         movwf       W_Temp      ;    W
                                    ;   W_Temp.
            movf        Status,W    ;    Status
                                    ;   W.
            movwf       Stat_Temp   ;    W
                                    ;   Stat_Temp.
            bcf         Status,RP0  ;   0-  (  0
                                    ; 5-  (RP0=0)  Status).
;------------------------------------------------------------------------------
;  :   (Bitvkl)    (Bitvykl).
;------------------------------------------------------------------------------
            clrwdt                  ;    WDT.
            bcf         GPIO,GP5    ;    GP5 .
            btfsc       GPIO,GP4    ;  GP4 = 0,  
                                    ;   btfsc Bitvkl,0.
            bcf         GPIO,GP4    ;    GP4 . 
            btfsc       Bitvkl,0    ;      Bitvkl
                                    ;  ,   
                                    ;  btfss Bitvykl,0.
            goto        Prov3       ;      Bitvkl 
                                    ;  (  ), 
                                    ;    Prov3.
            btfss       Bitvykl,0   ;      Bitvykl 
                                    ;  (  ), 
                                    ;    call Zad10p.
            goto        Prov4       ;      Bitvykl
                                    ;  ,   
                                    ;  Prov4.
            call        Zad10p      ;     Zad10p.
                                    ;  10    .
            bcf         Bitvykl,0   ;    0  Bitvykl .
            goto        Prov4       ;     Prov4.
Prov3       btfsc       GPIO,GP3    ;    (GP3 = 0), 
                                    ;    call Zad50p.
            goto        Nevkl       ;    (GP3 = 1), 
                                    ;    Nevkl.
            call        Zad50p      ;     Zad50p.
                                    ;  50   
                                    ;   .
            bcf         Bitvkl,0    ;    0  Bitvkl .
            goto        Vkl2        ;     Vkl2.
;------------------------------------------------------------------------------
; ,    .  ,  .
;------------------------------------------------------------------------------
Prov4       btfss       GPIO,GP3    ;    (GP3 = 1), 
                                    ;    Nevkl.
            goto        Vkl2        ;    (GP3 = 0), 
                                    ;    Vkl2.
Nevkl       movlw       0x06        ;    W  6.
                                    ;   5 :
                                    ;    .
            movwf       Taimer4     ;    W
                                    ;   Taimer4.
;------------------------------------------------------------------------------
;   .
;------------------------------------------------------------------------------
Povtor4     decfsz      Taimer4,F   ;    Taimer4.
            goto        ProvTel4    ;      ,
                                    ;     ProvTel4.
            bsf         BitGen,0    ;    0  BitGen
                                    ; ,   
                                    ;  .
            goto        Proverka    ;     Proverka.
ProvTel4    bsf         GPIO,GP4    ;    GP4 .
            call        Zad3p       ;     Zad3p.
                                    ;  3     .            
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad10p      ;     Zad10p.
                                    ;  10    .
            btfsc       GPIO,GP3    ;    (GP3 = 0), 
                                    ;    call Zad50p.
            goto        Povtor4     ;     (GP3 = 1), 
                                    ;    Povtor4.
            call        Zad50p      ;     Zad50p.
                                    ;  50   
                                    ;   .
            bcf         Bitvkl,0    ;    0  Bitvkl .
;------------------------------------------------------------------------------
;    .
;------------------------------------------------------------------------------
Vkl2        movlw       0x05        ;    W  5.
                                    ;   5 .
            movwf       Taimer5     ;    W
                                    ;   Taimer5.
;------------------------------------------------------------------------------
;   .
;------------------------------------------------------------------------------
Nabornom    bsf         GPIO,GP4    ;    GP4 .
            call        Zad200p     ;     Zad200p.
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad10p      ;     Zad10p.
                                    ;  10   .
            bsf         GPIO,GP4    ;    GP4 .
            call        Zad200p     ;     Zad200p.
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad500p     ;     Zad500p.
            bsf         GPIO,GP5    ;    GP5 .
            call        Zad200p     ;     Zad200p.
            bcf         GPIO,GP5    ;    GP5 .
            call        Zad500p     ;     Zad500p.
            bsf         GPIO,GP5    ;    GP5 .
            call        Zad200p     ;     Zad200p.
            bcf         GPIO,GP5    ;    GP5 .
            call        Zad50p      ;     Zad50p.
                                    ;   50    .
;------------------------------------------------------------------------------
; "" () .
;------------------------------------------------------------------------------
            decfsz      Taimer5,F   ;    Taimer5.
            goto        Nabornom    ;      ,
                                    ;     Nabornom.
                                    ;     ,
                                    ;     bsf GPIO,GP4.
;------------------------------------------------------------------------------
;   .
;------------------------------------------------------------------------------
            bsf         GPIO,GP4    ;    GP4 .
            call        Zad200p     ;     Zad200p.
            bcf         GPIO,GP4    ;    GP4 .
;------------------------------------------------------------------------------
; :  /    "",
;     "".
;   ,     "",  
;    .
;------------------------------------------------------------------------------
Proverka    movlw       0x00        ;    W  00.
            movwf       Perem       ;    W
                                    ;   Perem.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,0     ;   0  Perem .
            call        Zad125p     ;     Zad125p,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,1     ;   1  Perem .
            call        Zad125p     ;     Zad125p,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,2     ;   2  Perem .
            call        Zad125p     ;     Zad125p,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,3     ;   3  Perem .
            call        Zad125p     ;     Zad125p,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,4     ;   4  Perem .
            call        Zad125p     ;     Zad125p,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,5     ;   5  Perem .
            call        Zad125p     ;     Zad125p,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,6     ;   6  Perem .
            call        Zad125p     ;     Zad125p,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Perem,7     ;   7  Perem .
            movlw       0x00        ;    W  00.
            xorwf       Perem,W     ;  "-"
                                    ;   W  Perem.
            btfsc       Status,Z    ;  Z=0,   
                                    ;  movlw 0xFF.
            goto        EndInt      ;  Z=1,     EndInt.
            movlw       0xFF        ;    W  FF. 
            xorwf       Perem,W     ;  "-"
                                    ;   W  Perem.
            btfss       Status,Z    ;  Z=1,     EndInt.
            goto        Proverka    ;  Z=0,     Proverka.
            goto        EndInt      ;    EndInt.
;------------------------------------------------------------------------------
;  Zad125p (  125 ).
;------------------------------------------------------------------------------
Zad125p     movlw       0xFF        ;    W  255.
            movwf       SecLp       ;    W   SecLp.
            movlw       0x7A        ;    W  122.
            movwf       SecMp       ;    W   SecMp.
Snova8      clrwdt                  ;    WDT.
            decfsz      SecLp,F     ;    SecLp.
            goto        Snova8      ;      ,
                                    ;     Snova8.
            decfsz      SecMp,F     ;    SecMp.
            goto        Snova8      ;      ,
                                    ;     Snova8.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad200p (  200 ).
;------------------------------------------------------------------------------
Zad200p     movlw       0xFF        ;    W  255.
            movwf       SecLp       ;    W   SecLp.
            movlw       0xC3        ;    W  195.
            movwf       SecMp       ;    W   SecMp.
Snova9      clrwdt                  ;    WDT.
            decfsz      SecLp,F     ;    SecLp.
            goto        Snova9      ;      ,
                                    ;     Snova9.
            decfsz      SecMp,F     ;    SecMp.
            goto        Snova9      ;      ,
                                    ;     Snova9.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad500p (  500 ).
;------------------------------------------------------------------------------
Zad500p     movlw       0xFF        ;    W  255.
            movwf       SecLp       ;    W   SecLp.
            movlw       0xE7        ;    W  231.
            movwf       SecMp       ;    W   SecMp.
            movlw       0x02        ;    W  2.
            movwf       SecHp       ;    W   SecHp.
Snova10     clrwdt                  ;    WDT.
            decfsz      SecLp,F     ;    SecLp.
            goto        Snova10     ;      ,
                                    ;     Snova10.
            decfsz      SecMp,F     ;    SecMp.
            goto        Snova10     ;      ,
                                    ;     Snova10.
            decfsz      SecHp,F     ;    SecHp.
            goto        Snova10     ;      ,
                                    ;     Snova10.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad3p (  3 ).
;------------------------------------------------------------------------------
Zad3p       movlw       0xFF        ;    W  255.
            movwf       SecLp       ;    W   SecLp.
            movlw       0x6C        ;    W  108.
            movwf       SecMp       ;    W   SecMp.
            movlw       0x0C        ;    W  12.
            movwf       SecHp       ;    W   SecHp.
Snova11     clrwdt                  ;    WDT.
            decfsz      SecLp,F     ;    SecLp.
            goto        Snova11     ;      ,
                                    ;     Snova11.
            decfsz      SecMp,F     ;    SecMp.
            goto        Snova11     ;      ,
                                    ;     Snova11.
            decfsz      SecHp,F     ;    SecHp.
            goto        Snova11     ;      ,
                                    ;     Snova11.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad10p (  10 ).
;------------------------------------------------------------------------------
Zad10p      movlw       0xFF        ;    W  255.
            movwf       SecLp       ;    W   SecLp.
            movlw       0x6C        ;    W  108.
            movwf       SecMp       ;    W   SecMp.
            movlw       0x27        ;    W  39.
            movwf       SecHp       ;    W   SecHp.
Snova12     clrwdt                  ;    WDT.
            decfsz      SecLp,F     ;    SecLp.
            goto        Snova12     ;      ,
                                    ;     Snova12.
            decfsz      SecMp,F     ;    SecMp.
            goto        Snova12     ;      ,
                                    ;     Snova12.
            decfsz      SecHp,F     ;    SecHp.
            goto        Snova12     ;      ,
                                    ;     Snova12.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad30p (  30 ).
;------------------------------------------------------------------------------
Zad30p      movlw       0xFF        ;    W  255.
            movwf       SecLp       ;    W   SecLp.
            movlw       0xFF        ;    W  255.
            movwf       SecMp       ;    W   SecMp.
            movlw       0x73        ;    W  115.
            movwf       SecHp       ;    W   SecHp.
Snova13     clrwdt                  ;    WDT.
            decfsz      SecLp,F     ;    SecLp.
            goto        Snova13     ;      ,
                                    ;     Snova13.
            decfsz      SecMp,F     ;    SecMp.
            goto        Snova13     ;      ,
                                    ;     Snova13.
            decfsz      SecHp,F     ;    SecHp.
            goto        Snova13     ;      ,
                                    ;     Snova13.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad50p (  50 ).
;------------------------------------------------------------------------------
Zad50p      movlw       0xFF        ;    W  255.
            movwf       SecLp       ;    W   SecLp.
            movlw       0xFF        ;    W  255.
            movwf       SecMp       ;    W   SecMp.
            movlw       0xBF        ;    W  191.
            movwf       SecHp       ;    W   SecHp.
Snova14     clrwdt                  ;    WDT.
            decfsz      SecLp,F     ;    SecLp.
            goto        Snova14     ;      ,
                                    ;     Snova14.
            decfsz      SecMp,F     ;    SecMp.
            goto        Snova14     ;      ,
                                    ;     Snova14.
            decfsz      SecHp,F     ;    SecHp.
            goto        Snova14     ;      ,
                                    ;     Snova14.
            return                  ;     .
;------------------------------------------------------------------------------
;    Status  W   
;  .
;------------------------------------------------------------------------------
EndInt      movf        Stat_Temp,W ;   
                                    ; Stat_Temp   W.
            movwf       Status      ;    W
                                    ;   Status.
            swapf       W_Temp,F    ;     
                                    ;   W_Temp
                                    ;       .
            swapf       W_Temp,W    ;     
                                    ;   W_Temp  
                                    ;     W.
            bcf         IntCon,INTF ;     INT.
            bcf         Bitpost,0   ;    0  Bitpost .
            retfie                  ;     .
;------------------------------------------------------------------------------
;  .
;==============================================================================

;------------------------------------------------------------------------------
;  .
;------------------------------------------------------------------------------
St          bcf         Status,RP0  ;   0-  (  0
                                    ; 5-  (RP0=0)  Status).
            clrf        IntCon      ;   .
            clrf        GPIO        ;     GPIO  .
            clrf        Bitvkl      ;    
                                    ; Bitvkl  .
            clrf        Bitvykl     ;    
                                    ; Bitvykl  .
            clrf        Bitpost     ;    
                                    ; Bitpost  .
            clrf        BitGen      ;    
                                    ; BitGen  .
Start       bsf         Status,RP0  ;   1- .
            movlw       0x0F        ; (0000 1111)
            movwf       TrisIO      ; 1-, 0-.
            movlw       0x7F        ;     .
            movwf       Option_Reg  ;   .
            movlw       0x05        ; (0000 0101)
            movwf       Wpu         ;    
                                    ; GP0  GP2,  .
            movlw       0x2B        ; (0010 1011)
            movwf       Vrcon       ;    
                                    ; .
            movlw       0x00        ; (0000 0000)
            movwf       Ansel       ;   
                                    ; (    /).
            bcf         Status,RP0  ;   0-  (  0
                                    ; 5-  (RP0=0)  Status).
            movlw       0x07        ; (0000 0100)
            movwf       Cmcon0      ;  .
            clrwdt                  ;    WDT.
;------------------------------------------------------------------------------
; :        "".
;------------------------------------------------------------------------------
            btfss       Bitpost,0   ;      Bitpost
                                    ;  ,   
                                    ;  btfss BitGen,0.
            goto        VklVykl     ;      Bitpost
                                    ;  ,   
                                    ;  VklVykl.
            btfss       BitGen,0    ;      BitGen
                                    ;  ,   
                                    ;  call Zad500.
            goto        Prov2       ;      BitGen
                                    ;  ,   
                                    ;  Prov2.
            call        Zad500      ;     Zad500.
            call        Zad500      ;     Zad500.
            goto        Prov2       ;     Prov2.
VklVykl     call        Ohrana      ;     Ohrana.
            btfsc       Status,Z    ;  Z=0,   
                                    ;  clrf IntCon.
            goto        Prov1       ;  Z=1,     Prov1.
            clrf        IntCon      ;   .
            goto        Prov2       ;     Prov2.
;------------------------------------------------------------------------------
; ,    .  ,  .
;------------------------------------------------------------------------------
Prov1       btfss       GPIO,GP3    ;    (GP3 = 1), 
                                    ;    movlw 0x06.
            goto        Vkl1        ;    (GP3 = 0), 
                                    ;    Vkl1.
            movlw       0x06        ;    W  6.
                                    ;   5 :
                                    ;    .
            movwf       Taimer1     ;    W
                                    ;   Taimer1.
;------------------------------------------------------------------------------
;   .
;------------------------------------------------------------------------------
Povtor1     decfsz      Taimer1,F   ;    Taimer1.
            goto        ProvTel1    ;      ,
                                    ;     ProvTel1.
            goto        Generator   ;     ,
                                    ;     Generator. 
ProvTel1    bsf         GPIO,GP4    ;    GP4 .
            call        Zad3        ;     Zad3.
                                    ;  3     .            
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad10       ;     Zad10.
                                    ;  10    .
            btfsc       GPIO,GP3    ;    (GP3 = 0), 
                                    ;    call Zad50p.
            goto        Povtor1     ;     (GP3 = 1), 
                                    ;    Povtor1.
            call        Zad50       ;     Zad50.
                                    ;  50   
                                    ;   .
            goto        VklOhrana   ;     VklOhrana.
;------------------------------------------------------------------------------
; :        "".
;------------------------------------------------------------------------------
Vkl1        call        Zad10       ;     Zad10.
            call        Zad10       ;     Zad10.
                                    ;  20    .
VklOhrana   call        Ohrana      ;     Ohrana.
            btfss       Status,Z    ;  Z=1,   
                                    ;  movlw 0x90.
            goto        Prov2       ;  Z=0,     Prov2.
;------------------------------------------------------------------------------
;   INT.    "".
;------------------------------------------------------------------------------
            movlw       0x90        ;   144 (90h)   W.
            movwf       IntCon      ;  144 (1001 0000)   W
                                    ;   IntCon
                                    ; (    INT).
            bsf         Bitpost,0   ;    0 
                                    ; Bitpost .
;------------------------------------------------------------------------------
;   .   -    "".
;------------------------------------------------------------------------------
            bsf         GPIO,GP4    ;    GP4 .
            call        Zad250      ;     Zad250.
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad500      ;     Zad500.
            bsf         GPIO,GP4    ;    GP4 .
            call        Zad250      ;     Zad250.
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad500      ;     Zad500.
            bsf         GPIO,GP5    ;    GP5 .
            call        Zad250      ;     Zad250.
            bcf         GPIO,GP5    ;    GP5 .
            call        Zad500      ;     Zad500.
            bsf         GPIO,GP5    ;    GP5 .
            call        Zad250      ;     Zad250.
            bcf         GPIO,GP5    ;    GP5 .
            call        Zad50       ;     Zad50.
                                    ;   50    .
;------------------------------------------------------------------------------
;    50 .
;------------------------------------------------------------------------------
            bsf         GPIO,GP4    ;    GP4 .
            call        Zad250      ;     Zad250.
            bcf         GPIO,GP4    ;    GP4 .
;------------------------------------------------------------------------------
; ,     .
;   ,    .
;------------------------------------------------------------------------------
Prov2       btfss       GPIO,GP1    ;      (GP1 = 1), 
                                    ;    btfss GPIO,GP3.
            goto        Dalee1      ;      (GP1 = 0), 
                                    ;    Dalee1.
            btfss       GPIO,GP3    ;    (GP3 = 1), 
                                    ;    movlw 0x06.
            goto        Priem       ;    (GP3 = 0), 
                                    ;    Priem.
;------------------------------------------------------------------------------
;   .
;------------------------------------------------------------------------------
            movlw       0x06        ;    W  6.
                                    ;   5 :
                                    ;    .
            movwf       Taimer2     ;    W
                                    ;   Taimer2.
Povtor2     decfsz      Taimer2,F   ;    Taimer2.
            goto        ProvTel2    ;      ,
                                    ;     ProvTel2.
            goto        Generator   ;     ,
                                    ;     Generator.
ProvTel2    bsf         GPIO,GP4    ;    GP4 .
            bsf         Bitvkl,0    ;    0 
                                    ; Bitvkl .
            call        Zad3        ;     Zad3.
                                    ;  3     .
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad10       ;     Zad10.
                                    ;  10    .            
            btfss       GPIO,GP1    ;      (GP1 = 1), 
                                    ;    btfsc GPIO,GP3.
            goto        Dalee2      ;      (GP1 = 0), 
                                    ;    Dalee2.             
            btfsc       GPIO,GP3    ;    (GP3 = 0), 
                                    ;    call Zad50.
            goto        Povtor2     ;     (GP3 = 1), 
                                    ;    Povtor2.
            call        Zad50       ;     Zad50.
                                    ;  50   
                                    ;   .
            bcf         Bitvkl,0    ;    0  Bitvkl .
            goto        Priem       ;     Priem.
;------------------------------------------------------------------------------
; :    .
;------------------------------------------------------------------------------
Dalee1      btfsc       GPIO,GP3    ;    (GP3 = 0), 
                                    ;    movlw 0x06.
            goto        Dalee2      ;    (GP3 = 1), 
                                    ;    Dalee2.
;------------------------------------------------------------------------------
;   .
;------------------------------------------------------------------------------
            movlw       0x06        ;    W  6.
                                    ;   5 :
                                    ;    .
            movwf       Taimer3     ;    W
                                    ;   Taimer3.
Povtor3     decfsz      Taimer3,F   ;    Taimer3.
            goto        ProvTel3    ;      ,
                                    ;     ProvTel3.
            goto        Generator   ;     ,
                                    ;     Generator.
ProvTel3    bsf         GPIO,GP4    ;    GP4 .
            bsf         Bitvykl,0   ;    0 
                                    ; Bitvykl .
            call        Zad3        ;     Zad3.
                                    ;  3     .
            bcf         GPIO,GP4    ;    GP4 .
            call        Zad10       ;     Zad10.
                                    ;  10    .
            bcf         Bitvykl,0   ;    0  Bitvykl .
            btfsc       GPIO,GP1    ;      (GP1 = 0), 
                                    ;    btfss GPIO,GP3.
            goto        Dalee2      ;      (GP1 = 1), 
                                    ;    Dalee2.
            btfss       GPIO,GP3    ;    (GP3 = 1), 
                                    ;    Dalee2.
            goto        Povtor3     ;     (GP3 = 0), 
                                    ;    Povtor3.
            goto        Dalee2      ;     Dalee2.
;------------------------------------------------------------------------------
;   .
;------------------------------------------------------------------------------
Priem       btfsc       GPIO,GP0    ;    (GP0 = 0), 
                                    ;    call Zad10.
            goto        Dalee2      ;    (GP0 = 1), 
                                    ;    Dalee2.
            call        Zad10       ;     Zad10.
                                    ;  10 .
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            call        Zad500      ;     Zad500,  GP0=1.
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            call        Zad500      ;     Zad500,  GP0=1.
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            call        Zad500      ;     Zad500,  GP0=1.
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            call        Zad500      ;     Zad500,  GP0=1.
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            call        Zad250      ;     Zad250,  GP0=1.
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            call        Zad250      ;     Zad250,  GP0=1.
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            call        Zad250      ;     Zad250,  GP0=1.
            btfss       GPIO,GP0    ;    (GP0 = 0), 
            goto        Imp         ;    Imp.
            goto        Dalee2      ;       (GP0 = 1),
                                    ;     Dalee2.
Imp         bsf         GPIO,GP5    ;    GP5 .
            call        Zad250      ;     Zad250.
            bcf         GPIO,GP5    ;    GP5 .
Dalee2      btfsc       BitGen,0    ;      BitGen
                                    ;  ,   
                                    ;  call Zad125.
            goto        Generator   ;      BitGen
                                    ;  ,   
                                    ;  Generator.
            call        Zad125      ;  125 
                                    ; (   GP0,GP1,GP2,GP3).
            goto        Start       ;     Start.
;------------------------------------------------------------------------------
;  Ohrana.
; :        "".
;------------------------------------------------------------------------------
Ohrana      movlw       0x00        ;    W  00.
            movwf       Bitsost     ;    W
                                    ;   Bitsost.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,0   ;   0  Bitsost .
            call        Zad125      ;     Zad125,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,1   ;   1  Bitsost .
            call        Zad125      ;     Zad125,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,2   ;   2  Bitsost .
            call        Zad125      ;     Zad125,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,3   ;   3  Bitsost .
            call        Zad125      ;     Zad125,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,4   ;   4  Bitsost .
            call        Zad125      ;     Zad125,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,5   ;   5  Bitsost .
            call        Zad125      ;     Zad125,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,6   ;   6  Bitsost .
            call        Zad125      ;     Zad125,  GP2=0.
            btfsc       GPIO,GP2    ;  GP2=1,  
            bsf         Bitsost,7   ;   7  Bitsost .
            movlw       0x00        ;    W  00.
            xorwf       Bitsost,W   ;  "-" 
                                    ;  W  Bitsost.
            return                  ;     .
;------------------------------------------------------------------------------
;  Generator.  2500 .   2.
;------------------------------------------------------------------------------
Generator   btfsc       GPIO,GP1    ;      (GP1 = 0), 
                                    ;    clrf IntCon.
            goto        Est         ;      (GP1 = 1), 
                                    ;    Est.
;------------------------------------------------------------------------------
;     ,    "".
;------------------------------------------------------------------------------
            clrf        IntCon      ;   .
            bcf         Bitpost,0   ;    0 
                                    ; Bitpost .
;------------------------------------------------------------------------------
Est         bsf         Status,RP0  ;   1- .
            movlw       0x0E        ; (0000 1110)
            movwf       TrisIO      ; 1-, 0-.
            bcf         Status,RP0  ;   0-  (  0
                                    ; 5-  (RP0=0)  Status).
            bcf         Bitvkl,0    ;    0  Bitvkl .
Net         movlw       0xFF        ;    W  255.
            movwf       Taimer7     ;    W
                                    ;   Taimer7.
            movlw       0x14        ;    W  20.
            movwf       Taimer8     ;    W
                                    ;   Taimer8.
Ust0        bcf         GPIO,GP0    ;    GP0 .
            nop                     ;   .
            nop                     ;   .
            nop                     ;   .
            nop                     ;   .
Zagrconst   movlw       0x30        ;    W  48.
            movwf       Taimer6     ;    W
                                    ;   Taimer6.
Pause1      clrwdt                  ;    WDT.
            decfsz      Taimer6,F   ;    Taimer6.
            goto        Pause1      ;      ,
                                    ;     Pause1.
            btfsc       GPIO,GP0    ;  GP0 = 0, 
                                    ;    bsf GPIO,GP0.
            goto        Ust0        ;  GP0 = 1, 
                                    ;    Ust0.
            bsf         GPIO,GP0    ;    GP0 .
            decfsz      Taimer7,F   ;    Taimer7.
            goto        Zagrconst   ;      ,
                                    ;     Zagrconst.
            decfsz      Taimer8,F   ;    Taimer8.
            goto        Zagrconst   ;      ,
                                    ;     Zagrconst.
            bsf         GPIO,GP0    ;    GP0 .
            bsf         BitGen,0    ;    0
                                    ;  BitGen .
            btfss       GPIO,GP1    ;      (GP1 = 1), 
                                    ;    Start.
            goto        Net         ;      (GP1 = 0), 
                                    ;    Net.
            goto        Start       ;     Start.
;------------------------------------------------------------------------------
;  Zad125 (  125 ).
;------------------------------------------------------------------------------
Zad125      movlw       0xFF        ;    W  255.
            movwf       SecL        ;    W   SecL.
            movlw       0x7A        ;    W  122.
            movwf       SecM        ;    W   SecM.
Snova1      clrwdt                  ;    WDT.
            decfsz      SecL,F      ;    SecL.
            goto        Snova1      ;      ,
                                    ;     Snova1.
            decfsz      SecM,F      ;    SecM.
            goto        Snova1      ;      ,
                                    ;     Snova1.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad250 (  250 ).
;------------------------------------------------------------------------------
Zad250      movlw       0xFF        ;    W  255.
            movwf       SecL        ;    W   SecL.
            movlw       0xF4        ;    W  244.
            movwf       SecM        ;    W   SecM.
Snova2      clrwdt                  ;    WDT.
            decfsz      SecL,F      ;    SecL.
            goto        Snova2      ;      ,
                                    ;     Snova2.
            decfsz      SecM,F      ;    SecM.
            goto        Snova2      ;      ,
                                    ;     Snova2.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad500 (  500 ).
;------------------------------------------------------------------------------
Zad500      movlw       0xFF        ;    W  255.
            movwf       SecL        ;    W   SecL.
            movlw       0xE7        ;    W  231.
            movwf       SecM        ;    W   SecM.
            movlw       0x02        ;    W  2.
            movwf       SecH        ;    W   SecH.
Snova3      clrwdt                  ;    WDT.
            decfsz      SecL,F      ;    SecL.
            goto        Snova3      ;      ,
                                    ;     Snova3.
            decfsz      SecM,F      ;    SecM.
            goto        Snova3      ;      ,
                                    ;     Snova3.
            decfsz      SecH,F      ;    SecH.
            goto        Snova3      ;      ,
                                    ;     Snova3.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad3 (  3 ).
;------------------------------------------------------------------------------
Zad3        movlw       0xFF        ;    W  255.
            movwf       SecL        ;    W   SecL.
            movlw       0x6C        ;    W  108.
            movwf       SecM        ;    W   SecM.
            movlw       0x0C        ;    W  12.
            movwf       SecH        ;    W   SecH.
Snova4      clrwdt                  ;    WDT.
            decfsz      SecL,F      ;    SecL.
            goto        Snova4      ;      ,
                                    ;     Snova4.
            decfsz      SecM,F      ;    SecM.
            goto        Snova4      ;      ,
                                    ;     Snova4.
            decfsz      SecH,F      ;    SecH.
            goto        Snova4      ;      ,
                                    ;     Snova4.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad10 (  10 ).
;------------------------------------------------------------------------------
Zad10       movlw       0xFF        ;    W  255.
            movwf       SecL        ;    W   SecL.
            movlw       0x6C        ;    W  108.
            movwf       SecM        ;    W   SecM.
            movlw       0x27        ;    W  39.
            movwf       SecH        ;    W   SecH.
Snova5      clrwdt                  ;    WDT.
            decfsz      SecL,F      ;    SecL.
            goto        Snova5      ;      ,
                                    ;     Snova5.
            decfsz      SecM,F      ;    SecM.
            goto        Snova5      ;      ,
                                    ;     Snova5.
            decfsz      SecH,F      ;    SecH.
            goto        Snova5      ;      ,
                                    ;     Snova5.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad50 (  50 ).
;------------------------------------------------------------------------------
Zad50       movlw       0xFF        ;    W  255.
            movwf       SecL        ;    W   SecL.
            movlw       0xFF        ;    W  255.
            movwf       SecM        ;    W   SecM.
            movlw       0xBF        ;    W  191.
            movwf       SecH        ;    W   SecH.
Snova7      clrwdt                  ;    WDT.
            decfsz      SecL,F      ;    SecL.
            goto        Snova7      ;      ,
                                    ;     Snova7.
            decfsz      SecM,F      ;    SecM.
            goto        Snova7      ;      ,
                                    ;     Snova7.
            decfsz      SecH,F      ;    SecH.
            goto        Snova7      ;      ,
                                    ;     Snova7.
            return                  ;     .
            end                     ;  .